// D70D80GPIBControlDlg.cpp 
//
//////////////////////////////////////////////////////////////////
//
//		x͐@	cVO^cWOV[Y
//					Rg[TvvO
//
//		j̃TvvOgpɂA
//			NationalInsturumentsЂ񋟂ȉ
//			̃t@CvWFNgɒǉKv
//			܂B
//				- Decl-32.h
//				- gpib-32.obj
//////////////////////////////////////////////////////////////////					

#include "stdafx.h"
#include "D70D80GPIBControl.h"
#include "D70D80GPIBControlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CD70D80GPIBControlDlg Dialog

CD70D80GPIBControlDlg::CD70D80GPIBControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CD70D80GPIBControlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CD70D80GPIBControlDlg)
	m_iLSpeed = 100;
	m_iPosition = 0;
	m_iRate = 200;
	m_iSpeed = 2000;
	m_strStatus = _T("");
	m_iStep = 100;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CD70D80GPIBControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CD70D80GPIBControlDlg)
	DDX_Control(pDX, IDC_CW, m_pCCWButton);
	DDX_Control(pDX, IDC_CCW, m_pCWButton);
	DDX_Text(pDX, IDC_LSPEED, m_iLSpeed);
	DDV_MinMaxInt(pDX, m_iLSpeed, 0, 9999);
	DDX_Text(pDX, IDC_POSITION, m_iPosition);
	DDX_Text(pDX, IDC_RATE, m_iRate);
	DDV_MinMaxInt(pDX, m_iRate, 0, 9999);
	DDX_Text(pDX, IDC_SPEED, m_iSpeed);
	DDV_MinMaxInt(pDX, m_iSpeed, 1, 240000);
	DDX_Text(pDX, IDC_STATUS, m_strStatus);
	DDX_Text(pDX, IDC_STEP, m_iStep);
	DDV_MinMaxInt(pDX, m_iStep, 1, 9999999);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CD70D80GPIBControlDlg, CDialog)
	//{{AFX_MSG_MAP(CD70D80GPIBControlDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_MODE_CONT, OnModeCont)
	ON_BN_CLICKED(IDC_MODE_ORG, OnModeOrg)
	ON_BN_CLICKED(IDC_MODE_STEP, OnModeStep)
	ON_BN_CLICKED(IDC_SET_POSITION, OnSetPosition)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_CBN_SELCHANGE(IDC_BOARD_NUMBER, OnSelchangeBoardNumber)
	ON_CBN_SELCHANGE(IDC_GPIB_ADDRESS, OnSelchangeGpibAddress)
	ON_CBN_SELCHANGE(IDC_AXIS, OnSelchangeAxis)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_MY_LBUTTON_DOWN,OnDown)
	ON_MESSAGE(WM_MY_LBUTTON_UP,OnUp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

BOOL CD70D80GPIBControlDlg::OnInitDialog()
{
	// SURUGA >>
	// {^Rg[̃TuNX
	m_pCWButton.SubclassDlgItem(IDC_CW,this);
	m_pCCWButton.SubclassDlgItem(IDC_CCW,this);
	// << SURUGA

	CDialog::OnInitDialog();


	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	SetIcon(m_hIcon, TRUE);	
	SetIcon(m_hIcon, FALSE);
	
	// SURUGA >>
	iUD = 0;		// GP-IB̏ςłȂƂ𖾎
	nTimerID=1;		// ^C}ID
	bStopFlag = FALSE;
	// eRg[̏s
	SetEnableControl(FALSE);									// GPIBݒpȊÕRg[gpsɂ
	((CComboBox*)GetDlgItem(IDC_BOARD_NUMBER))->SetCurSel(0);	// GPIB{[h̃ftHgliOjݒ肷
	((CComboBox*)GetDlgItem(IDC_GPIB_ADDRESS))->SetCurSel(7);	// Rg[GPIBAhX̃ftHgliVjݒ肷
	((CComboBox*)GetDlgItem(IDC_AXIS))->SetCurSel(0);			// 쓮̃ftHglƂAxis1ݒ肷
	((CComboBox*)GetDlgItem(IDC_ORG))->SetCurSel(0);			// _A[h̃ftHglƂORG1ݒ肷
	((CButton*)GetDlgItem(IDC_MODE_CONT))->SetCheck(1);			// 샂[h̏ݒƂĘAړ[hݒ肷
	((CButton*)GetDlgItem(IDOK))->EnableWindow(TRUE);
	((CButton*)GetDlgItem(IDCANCEL))->EnableWindow(TRUE);

	OnSelchangeGpibAddress();	// GPIB̏s
	OnSelchangeAxis();			// ړ̏s
	// << SURUGA

	return TRUE;
}

void CD70D80GPIBControlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CD70D80GPIBControlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); 

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CD70D80GPIBControlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CD70D80GPIBControlDlg::OnDown(WPARAM wParam,LPARAM lParam) 
{
	// SURUGA >>
	//
	//	ړ{^ibv܂͂bbvjꂽꍇ̏
	//	
	//	ړ[h𒲂ׁCȉ̏s
	//    Aړ[hFXe[ẄړJn
	//	  ̑		FȂBۂ̈ړ̓{^ꂽƂs
	//

	CString strMessage;					// R}hMpobt@
	if (!UpdateData(TRUE)) return;		// _CAO̍XVe𔽉fA̓~XΊ֐𔲂
	if (iUD == 0) return;				// foCX̏ĂȂΉȂ

	if (GetCheckedRadioButton(IDC_MODE_CONT,IDC_MODE_ORG) == IDC_MODE_CONT) {	// IĂ铮샂[h𒲂ׂ
		// Xe[W̓샂[hAړ[ĥƂɂ́AړJn
		if (wParam == IDC_CW) strMessage.Format("P9999999L%dR%dF%dUG",m_iLSpeed,m_iRate,m_iSpeed);	// CWɈړꍇ̈ړR}hZbg
		else				  strMessage.Format("P9999999L%dR%dF%dDG",m_iLSpeed,m_iRate,m_iSpeed);	// CCWɈړꍇ̈ړR}hZbg
		SendGpibString(GetAxisString()+strMessage);		
		nTimerID = SetTimer(nTimerID,50,NULL);			// ʍXVp̃^C}荞݂Zbg
	}
	// << SURUGA
}

void CD70D80GPIBControlDlg::OnUp(WPARAM wParam,LPARAM lParam) 
{
	// SURUGA >>
	//
	//	ړ{^ꂽ̏
	//
	//	ړ[h𒲂ׁCȉ̏s
	//		Aړ[h@@FXe[W~
	//		Xebvړ[hFXe[ẄړE~mFs
	//		_A[h@@FXCb`ݒ肵AXe[ẄړE~mFs
	//

	CString strMessage;		// R}hMpobt@
	if (iUD == 0) return;	// foCX̏ĂȂΉȂ

	switch(GetCheckedRadioButton(IDC_MODE_CONT,IDC_MODE_ORG)){ // Xe[W̓샂[h𒲂ׂ
	case IDC_MODE_CONT:			// Aړ[h̏ꍇ́AXe[W̒~s
		OnStop();				// Xe[W~
		KillTimer(nTimerID);	// ʍXVp̃^C}荞݂؂
		break;

	case IDC_MODE_STEP:			// Xebvړ[h̏ꍇ́AXe[ẄړJns
		if (!UpdateData(TRUE)) return;							// _CAO̍XVe𔽉fA̓~XΊ֐𔲂
		if (wParam == IDC_CW) strMessage.Format("P%dL%dR%dF%dUG",m_iStep,m_iLSpeed,m_iRate,m_iSpeed);	// ړbv̎̃p[^Zbg
		else				  strMessage.Format("P%dL%dR%dF%dDG",m_iStep,m_iLSpeed,m_iRate,m_iSpeed);	// ړbbv̎̃p[^Zbg
		SetEnableControl(FALSE);								// SẴRg[ύXs\ɂ
		((CButton*)GetDlgItem(IDC_STOP))->EnableWindow(TRUE);	// rsno{^̂ݎgp\ɂ
		ClearSPByteBuffer();									// ~mFp̃VA|[obt@̓eNA
		bStopFlag = FALSE;										// ~tONA
		SendGpibString(GetAxisString()+strMessage);				// ړR}h𑗐M
		CheckStop();											// ~mFs
		SetEnableControl(TRUE);									// Rg[gp\ɂ
		break;

	case IDC_MODE_ORG:			// _A[h̏ꍇ́AXCb`ݒ肵Č_As
		if (!UpdateData(TRUE)) return;													// _CAO̍XVe𔽉fA̓~XΊ֐𔲂
		strMessage.Format( "1%d",((CComboBox*)GetDlgItem(IDC_ORG))->GetCurSel() );		// _AύXR}hZbg
		SendGpibString("M" + GetAxisString()+strMessage);								// _A̕ύXR}h𑗐M
		SetEnableControl(FALSE);														// SẴRg[ύXs\ɂ
		((CButton*)GetDlgItem(IDC_STOP))->EnableWindow(TRUE);							// rsno{^̂ݎgp\ɂ
		ClearSPByteBuffer();															// ~mFp̃VA|[obt@̓eNA
		bStopFlag = FALSE;																// ~tONA
		strMessage.Format( "L%dR%dF%d",m_iLSpeed,m_iRate,m_iSpeed);						// _AsR}hZbg
		SendGpibString(GetAxisString()+strMessage);										// _A̋쓮p[^ݒ肷
		SendGpibString(GetAxisString()+"O");											// _AJn
		CheckStop();																	// ~mFs
		SetEnableControl(TRUE);															// Rg[gp\ɂ
		break;
	}
	// << SURUGA
}

void CD70D80GPIBControlDlg::OnModeCont() 
{
	// SURUGA >>
	//
	//	Aړ[hIꂽƂ̏
	//
	((CButton*)GetDlgItem(IDC_STEP))->EnableWindow(FALSE);	// Xebvړ[h̃GfBbg{bNXύXs\ɂ
	((CComboBox*)GetDlgItem(IDC_ORG))->EnableWindow(FALSE);	// _A[h̃R{{bNXύXs\ɂ
	SetButtonCaption(FALSE);								// 쓮{^̃eLXgݒ肷 
	// << SURUGA
}

void CD70D80GPIBControlDlg::OnModeOrg() 
{
	// SURUGA >>
	//
	//	_A[hIꂽƂ̏
	//
	((CButton*)GetDlgItem(IDC_STEP))->EnableWindow(FALSE);	// Xebvړ[h̃GfBbg{bNXύXs\ɂ
	((CComboBox*)GetDlgItem(IDC_ORG))->EnableWindow(TRUE);	// _A[h̃R{{bNXύX\ɂ
	SetButtonCaption(TRUE);									// 쓮{^̃eLXgݒ肷
	// << SURUGA 
}

void CD70D80GPIBControlDlg::OnModeStep() 
{
	// SURUGA >>
	//
	//	Xebvړ[hIꂽƂ̏
	//
	((CButton*)GetDlgItem(IDC_STEP))->EnableWindow(TRUE);	// Xebvړ[h̃GfBbg{bNXύX\ɂ
	((CComboBox*)GetDlgItem(IDC_ORG))->EnableWindow(FALSE);	// _A[h̃R{{bNXύXs\ɂ
	SetButtonCaption(FALSE);								// 쓮{^̃eLXgݒ肷
	// << SURUGA
}

void CD70D80GPIBControlDlg::OnSetPosition() 
{
	// SURUGA >>
	//
	//	|WVݒ{^ꂽƂ̏
	//
	CSetPositionDlg dlgSetPosition;					// |WVZbgp̃_CAO
	dlgSetPosition.m_iPosition = GetPositionData();	// ݂̃|WV_CAOł̏lƂ
	if (dlgSetPosition.DoModal()==IDOK)	{		
		m_iPosition = dlgSetPosition.m_iPosition;	// V|WVݒ肷
		SetPositionData(m_iPosition);
		UpdateData(FALSE);			
	}
	// << SURUGA
}

void CD70D80GPIBControlDlg::OnStop() 
{
	// SURUGA >>
	//
	// rsno{^ꂽƂ̏
	//
	if (iUD == 0) return;			// GPIBfoCXĂȂꍇ͉Ȃ
	SendGpibString("E");			// S~R}h𑗐M
	while (1) {
		if (GetAxisStatus() != 1) break;	// ̒~mF
	}
	bStopFlag=TRUE;					
	m_iPosition = GetPositionData();
	UpdateData(FALSE);
	// << SURUGA
}

void CD70D80GPIBControlDlg::OnTimer(UINT nIDEvent) 
{
	// SURUGA >>
	//
	// ^C}荞݂Ƃ̏
	//
	// Xe[W̃Xe[^Xƃ|WVʂɕ\
	//
	if(iUD == 0) return;				// foCX̏ĂȂΉȂ
	GetAxisStatus();					// ĨXe[^XXV
	m_iPosition = GetPositionData();	// ݂̃|WV擾
	UpdateData(FALSE);					

	if (nIDEvent != NULL) CDialog::OnTimer(nIDEvent);	// ^C}荞݂ɂČĂ΂ꂽꍇ͊{NX̃Cvgs
	// CDialog::OnTimer(nIDEvent);

	// << SURUGA
}

void CD70D80GPIBControlDlg::OnOK() 
{
	// SURUGA >>
	//
	// OK{^ꂽƂ̏
	//
	if (iUD != 0) ibonl(iUD,0);	

	// << SURUGA

	CDialog::OnOK();
}

void CD70D80GPIBControlDlg::OnCancel() 
{
	// SURUGA >>
	//
	// Cancel{^ꂽƂ̏
	//
	if (iUD != 0) ibonl(iUD,0);	

	// << SURUGA

	CDialog::OnCancel();
}

// SURUGA >>

void CD70D80GPIBControlDlg::SetEnableControl(BOOL bFlag){
//
//	eRg[̎gp\Ԃ؂肩
//
	// OKALZ{^̐ݒ
	((CButton*)GetDlgItem(IDOK))->EnableWindow(bFlag);
	((CButton*)GetDlgItem(IDCANCEL))->EnableWindow(bFlag);
	// 쓮p{^̐ݒ
	((CButton*)GetDlgItem(IDC_CW))->EnableWindow(bFlag);
	((CButton*)GetDlgItem(IDC_CCW))->EnableWindow(bFlag);
	((CButton*)GetDlgItem(IDC_STOP))->EnableWindow(bFlag);
	// 쓮p[^pGfBbg{bNX̐ݒ
	((CEdit*)GetDlgItem(IDC_LSPEED))->EnableWindow(bFlag);
	((CEdit*)GetDlgItem(IDC_RATE))->EnableWindow(bFlag);
	((CEdit*)GetDlgItem(IDC_SPEED))->EnableWindow(bFlag);
	// 쓮[h؂ւp{^̐ݒ
	((CButton*)GetDlgItem(IDC_MODE_CONT))->EnableWindow(bFlag);
	((CButton*)GetDlgItem(IDC_MODE_STEP))->EnableWindow(bFlag);
	((CButton*)GetDlgItem(IDC_MODE_ORG))->EnableWindow(bFlag);
	((CEdit*)GetDlgItem(IDC_STEP))->EnableWindow(FALSE);
	((CComboBox*)GetDlgItem(IDC_ORG))->EnableWindow(FALSE);
	if (bFlag == TRUE) {
		((CEdit*)GetDlgItem(IDC_STEP))    -> EnableWindow( ((CButton*)GetDlgItem(IDC_MODE_STEP))->GetCheck() == 1);
		((CComboBox*)GetDlgItem(IDC_ORG)) -> EnableWindow( ((CButton*)GetDlgItem(IDC_MODE_ORG ))->GetCheck() == 1);
	}
	// |WVύX{^̐ݒ
	((CButton*)GetDlgItem(IDC_SET_POSITION)) -> EnableWindow(bFlag);
}

void CD70D80GPIBControlDlg::SetButtonCaption(BOOL bOrgFlag){
//
// I쓮[hɂAe쓮{^̗LE肷
//
	if (bOrgFlag == TRUE) {
		// ORG[hIĂꍇ́ACW,CCW쓮{^̗Ɂu_AJnvƕ\
		((CButton*)GetDlgItem(IDC_CW ))->SetWindowText("_AJn");
		((CButton*)GetDlgItem(IDC_CCW))->SetWindowText("_AJn");
	}
	else{
		// ̑̃[hIĂꍇ́Ae쓮{^Ɉړ\
		((CButton*)GetDlgItem(IDC_CW ))->SetWindowText("ړi{j");
		((CButton*)GetDlgItem(IDC_CCW))->SetWindowText("i|jړ");
	}
}

int CD70D80GPIBControlDlg::ConnectGPIB(int iBoardNumber,int iAddress){
//
// GPIBڑ
//
	if (iUD != 0){
		// ȑOɃRg[ƐڑĂA̐ڑ؂藣
		ibonl (iUD,0);
	}
	short ln;

	//
	// GPIBfoCX
	//
	ibconfig (iBoardNumber,7,0);						//VA|[O𖳌
	iUD=ibdev(iBoardNumber,iAddress,0,T1s,1,0x140a);	// GPIBfoCX
	if (ibsta & ERR) {									// GPIBG[rbg̔f
		m_strStatus = "GPIBڑG[";
		UpdateData(FALSE);
		iUD = 0;										// foCX̏ςłȂƂ𖾎
		return -1;
	}
	Sleep(50);
	
	//
	// GPIBfoCX݂邩mF
	//
	for (int i=0;i<10;i++){					// 10mFs
		ibln(iUD,iAddress,0,&ln);			// ڑmFs
		if (ibsta & ERR) {					// GPIBG[rbg̔f
			m_strStatus = "GPIBڑG[";
			UpdateData(FALSE);
			ibonl (iUD,0);
			iUD = 0;						// foCX̏ςłȂƂ𖾎
			return -1;
		}
		else if (ln != 0)break;				// ڑmFł烋[v𔲂
	}
	if (ln == 0) {
		m_strStatus = "GPIBfoCX݂܂";
		UpdateData(FALSE);
		ibonl(iUD,0);						// foCX؂藣
		iUD=0;								// foCX̏ςłȂƂ𖾎
		return -1;
	}
	return 0;
}
	
int CD70D80GPIBControlDlg::GetPositionData(){
//
// Wf[^Rg[M
//
	CString strPosition;

	if (SendGpibString("?" + GetAxisString()) == FALSE){	
		m_strStatus = "GP-IB񑗐MG[";
		UpdateData(FALSE);
		return 0;
	}
	if (ReceiveGpibString(strPosition)== FALSE) {
		m_strStatus = "GP-IBMG[";
		UpdateData(FALSE);
		return 0;
	}
	return atoi(strPosition);
}	

void CD70D80GPIBControlDlg::OnSelchangeBoardNumber() 
{
	OnSelchangeGpibAddress();	
}

void CD70D80GPIBControlDlg::OnSelchangeGpibAddress() 
{
	//
	// GP-IBAhXύXꂽꍇAGP-IB̍ĐڑƊmFs
	//
	int iBoardNumber;
	int iAddress;
	iBoardNumber = ((CComboBox*)GetDlgItem(IDC_BOARD_NUMBER))->GetCurSel();
	iAddress = ((CComboBox*)GetDlgItem(IDC_GPIB_ADDRESS))->GetCurSel();
	if (ConnectGPIB(iBoardNumber,iAddress)==0) {
		SetEnableControl(TRUE);
		m_strStatus = "GPIBڑ";
	}
	else {
		SetEnableControl(FALSE);
		m_strStatus = " GPIBfoCX܂";
		((CButton*)GetDlgItem(IDOK))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDCANCEL))->EnableWindow(TRUE);
	}
	UpdateData(FALSE);

	SendGpibString("#");			// SRQ̔
}

void CD70D80GPIBControlDlg::OnSelchangeAxis() 
{
	SendGpibString(GetAxisString());
	GetAxisStatus();
	m_iPosition = GetPositionData();
	UpdateData(FALSE);
}

int CD70D80GPIBControlDlg::GetAxisStatus(){
// ĨXe[^X擾
// ߂lF	|P@GPIBł̐ڑł܂B
//			@O@~
//@@@@@@P@ړ
//@@@@@@Q@bv~bgo
//			@R@bbv~bgo
//			@S@_ʒuŒ~
//			 PO Is

	CString strStatus;
	int iStatus = 0;
	if (iUD == 0) return -1;								// GPIBŐڑĂȂꍇ̓G[ŕA

	// Xe[^X̎擾ƊmF

	if (SendGpibString ("%" + GetAxisString())==FALSE){
		m_strStatus = "GP-IB񑗐MG[";
		return -1;
	}
	if (ReceiveGpibString(strStatus) == FALSE){
		m_strStatus = "GP-IBMG[";
		return -1;
	}
	if (!(strStatus[1] & 0x80)) {
		m_strStatus = "Is\";
		return 10;
	}
	
	if (strStatus[0] & 0x80) {
		m_strStatus = "ړ";
		return 1;
	}
	if ((strStatus[0] & 0x18) == 0x18) {
		m_strStatus = "Is";
		return 10;
	}
	if (strStatus[0] & 0x10) {
		m_strStatus = "bv~bgo";
		return 2;
	}
	if (strStatus[0] & 0x08) {
		m_strStatus = "bbv~bgo";
		return 3;
	}
	if (strStatus[0] & 0x40) {
		m_strStatus = "_ʒu";
		return 4;
	}
	m_strStatus = "~";
	return 0;
}

BOOL CD70D80GPIBControlDlg::SendGpibString(CString strMessage){
//
// GPIBfoCXɕ𑗐M
//
	char cCommand[255];
	if (iUD == 0) return FALSE;				// GPIBfoCX̏ςłȂ΃G[I
	strMessage += "\r\n";					// MɃf~^ǉ
	strcpy(cCommand,strMessage);			// ϒ񂩂Œ蒷֕ϊ
	int iCount = strMessage.GetLength();	// ̒擾
	ibwrt(iUD,cCommand,iCount);				// GPIBfoCX֕𑗐M
	if (ibsta & (ERR | TIMO)) {
		return FALSE;						// G[^CAEgƂɂ̓G[I
	}
	return TRUE;
}

BOOL CD70D80GPIBControlDlg::ReceiveGpibString(CString& strMessage){
//
// GPIBfoCX當M
//
	char cReceiveBuf[255];

	if (iUD == 0) return FALSE;				// GPIBfoCX̏ςłȂ΃G[I
	ibrd(iUD,cReceiveBuf,255);				// foCX̑Mf[^Œ蒷֊i[
	if (ibsta & (ERR | TIMO)) {
		return FALSE;						// G[^CAEgƂ̓G[I
	}
	strMessage=cReceiveBuf;
	return TRUE;
}

CString CD70D80GPIBControlDlg::GetAxisString(){
//
// R{{bNXőIĂ鎲́Aw蕶Ԃ
//
	CString strAxis;
	strAxis.Format("A%d",((CComboBox*)GetDlgItem(IDC_AXIS))->GetCurSel()+1);
	return strAxis;
}

void CD70D80GPIBControlDlg::ClearSPByteBuffer(){
//
// obt@ɗ܂ĂVA|[oCg폜
//
	char cSPByte;
	if (iUD == 0) return;			// foCX̏ĂȂꍇ͉Ȃ
	while(1) {
		ibrsp(iUD,&cSPByte);		// VA|[oCgfoCXM
		if (cSPByte == 0) break;	// VA|[oCgȂ烋[v𔲂
	}
}

void CD70D80GPIBControlDlg::CheckStop(){
//
// rqpgpAXe[W̒~mF
//
	char cSPByte;
	int iBoardNumber;
	MSG msg;

	nTimerID = SetTimer(nTimerID,200,NULL);	// ʍXVp̃^C}Zbg
											// NOTE:SRQł̒~mFsꍇ́A^C}荞݊ԊuQOOȏɂĂB
											//      ^C}ԊuZƃXe[^XMɂRg[BUSYɂȂA
											//      SRQtO̐ݒ肪ȂȂ鋰ꂪ܂B

	iBoardNumber = ((CComboBox*)GetDlgItem(IDC_BOARD_NUMBER))->GetCurSel();	// IĂGPIB{[h̃{[hԍM
	while (1){
		while (1){
			short sSRQ;
			while( PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) != 0){	// Windows̃bZ[W
				TranslateMessage(&msg);	
				DispatchMessage(&msg);
			}

			TestSRQ(iBoardNumber,&sSRQ);	// rqpCAT[gĂ邩mF						
			if (sSRQ != 0) break;			// AT[gĂ烋[v𔲂
			if (ibsta & ERR) break;			// GPIBG[烋[v𔲂
			if (bStopFlag) break;			// rsno{^Ă烋[v𔲂
		}
		if (bStopFlag) break;			// rsno{^Ă烋[v𔲂
		ibrsp(iUD,&cSPByte);			// Rg[փVA|[s
		if (cSPByte != 0x00) break;		// MSRQoCgOłȂꍇ̓[v𔲂
	}

	KillTimer(nTimerID);		// ^C}荞݂
	SetEnableControl(TRUE);		// Rg[gp\ɂ
	OnTimer(NULL);				// ʍXVs
}

void CD70D80GPIBControlDlg::SetPositionData(int iPositionData){
//
// Xe[W̃|WVύX
//
	CString strMessage;
	int iabsPositionData;
	iabsPositionData = abs(iPositionData);
	if(iPositionData >= 0)	strMessage.Format("S%d",iPositionData);
	else					strMessage.Format("SL%d",iPositionData);
	SendGpibString(GetAxisString()+strMessage);
}

// << SURUGA
